# -----------File Discription----------
# filename:	hxp_wafter_raster_scan.tcl
# author:	P. Dinh
# company:  Newport Corporation
# date:		April 8, 2013
# # 
# Description: HXP50 demo for vision tradeshow
# ----------------------------------------

puts stdout "Script Begins"

# Display error and close procedure
proc DisplayErrorAndClose {socketID code APIName} {
	global tcl_argv
	if {$code != -2 && $code != -108} {
		set code2 [catch "ErrorStringGet $socketID $code strError"]
		if {$code2 != 0} {
			puts stdout "$APIName ERROR => $code - ErrorStringGet ERROR => $code2"
			set tcl_argv(0) "$APIName ERROR => $code"
		} else {
			puts stdout "$APIName $strError"
			set tcl_argv(0) "$APIName $strError"
		}
	} else {
		if {$code == -2} {
			puts stdout "$APIName ERROR => $code : TCP timeout"
			set tcl_argv(0) "$APIName ERROR => $code : TCP timeout"
		} 
		if {$code == -108} {
			puts stdout "$APIName ERROR => $code : The TCP/IP connection was closed by an administrator"
			set tcl_argv(0) "$APIName ERROR => $code :  The TCP/IP connection was closed by an administrator"
		} 
	}
	set code2 [catch "TCP_CloseSocket $socketID"] 
	return
}


# Main process 
set TimeOut 20 
set code 0 


# Open TCP socket 
OpenConnection $TimeOut socketID 
if {$socketID == -1} { 
	puts stdout "OpenConnection failed => $socketID" 
	return 
} 
after 500

# Kill All
set code [catch "KillAll $socketID "] 
if {$code != 0} { 
	DisplayErrorAndClose $socketID $code "KillAll" 
	return 
} 


# Initialize
set code [catch "GroupInitialize $socketID HEXAPOD"] 
if {$code != 0} { 
	DisplayErrorAndClose $socketID $code "GroupInitialize" 
	return 
} 


# Home Search
set code [catch "GroupHomeSearch $socketID HEXAPOD"] 
if {$code != 0} { 
	DisplayErrorAndClose $socketID $code "GroupHomeSearch" 
	return 
} 

# Relative move Z; to focal point of the camera
set code [catch "HexapodMoveIncremental $socketID HEXAPOD Work 0 0 7 0 0 0"] 
if {$code != 0} { 
	DisplayErrorAndClose $socketID $code "HexapodMoveIncremental" 
	return 
} 

set i 0


puts stdout "i is $i"



while {$i<10000} {
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Arc 3 3 3 0"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		} 
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Arc -6 -6 -6 0"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		}
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Arc 3 3 3 0"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		} 
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Line 0 0 2 0"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		} 
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Line 0 0 -4 0"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		} 
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Line 0 0 2 0"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		} 
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Line 0 8 0 10"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		} 
				set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Arc 3 3 3 5"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		} 
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Arc -6 -6 -6 5"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		}
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Arc 3 3 3 5"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		} 
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Line 0 0 2 0"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		} 
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Line 0 0 -4 0"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		} 
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Line 0 0 2 0"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		} 
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Line 1 0 0 10"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		} 
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Line 0 -8 0 10"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		} 
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Line 1 0 0 10"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		} 
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Line 0 8 0 10"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		}
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Line 1 0 0 10"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		} 
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Line 0 -8 0 10"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		} 
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Line 1 0 0 10"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		} 
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Line 0 8 0 10"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		}
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Line 1 0 0 10"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		} 
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Line 0 -8 0 10"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		} 
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Line 1 0 0 10"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		} 
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Line 0 8 0 10"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		}
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Line 1 0 0 10"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		} 
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Line 0 -8 0 10"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		} 
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Line 1 0 0 10"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		} 
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Line 0 8 0 10"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		}
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Arc 3 3 3 5"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		} 
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Arc -6 -6 -6 5"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		}
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Arc 3 3 3 5"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		} 
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Line 0 0 2 0"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		} 
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Line 0 0 -4 0"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		} 
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Line 0 0 2 0"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		}  
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Line 0 -8 0 10"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		}
				set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Arc 3 3 3 5"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		} 
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Arc -6 -6 -6 5"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		}
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Arc 3 3 3 5"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		} 
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Line -8 0 0 10"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		}
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Line 0 0 2 0"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		} 
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Line 0 0 -4 0"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		} 
		set code [catch "HexapodMoveIncrementalControlWithTargetVelocity $socketID HEXAPOD Work Line 0 0 2 0"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncrementalControlWithTargetVelocity" 
		return 
		} 
		# Kill All
		set code [catch "KillAll $socketID "] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "KillAll" 
		return 
		} 

		# Initialize
		set code [catch "GroupInitialize $socketID HEXAPOD"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "GroupInitialize" 
		return 
		} 

		# Home Search
		set code [catch "GroupHomeSearch $socketID HEXAPOD"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "GroupHomeSearch" 
		return 
		} 
		
		after 5000
		
		# Relative move Z; to focal point of the camera
		set code [catch "HexapodMoveIncremental $socketID HEXAPOD Work 0 0 7 0 0 0"] 
		if {$code != 0} { 
		DisplayErrorAndClose $socketID $code "HexapodMoveIncremental" 
		return 
		}	 
		incr i 1
		puts stdout "i is $i"
	} 
			

}
# Close TCP socket 

TCP_CloseSocket $socketID 

